import ResizeObserver from 'resize-observer-polyfill';
import IntersectionObserver from 'intersection-observer';
var ElementRectObserver = (function () {
    function ElementRectObserver(listener, contentWindow) {
        var _this = this;
        if (contentWindow === void 0) { contentWindow = window; }
        this.onChange = function () {
            var _a;
            _this.listener((_a = _this.target) === null || _a === void 0 ? void 0 : _a.getBoundingClientRect());
        };
        this.listener = listener;
        this.contentWindow = contentWindow;
        this.resizeObserver = new ResizeObserver(this.onChange);
        this.intersectionObserver = new IntersectionObserver(this.onChange);
    }
    ElementRectObserver.prototype.observe = function (element) {
        this.target = element;
        this.resizeObserver.observe(element);
        this.intersectionObserver.observe(element);
        this.contentWindow.addEventListener('resize', this.onChange);
        this.contentWindow.addEventListener('scroll', this.onChange);
    };
    ElementRectObserver.prototype.unobserve = function (element) {
        this.target = null;
        this.resizeObserver.unobserve(element);
        this.intersectionObserver.unobserve(element);
        this.contentWindow.removeEventListener('resize', this.onChange);
        this.contentWindow.removeEventListener('scroll', this.onChange);
    };
    return ElementRectObserver;
}());
export { ElementRectObserver };
