import { useEffect, useCallback } from 'react';
import { ElementRectObserver } from './ElementRectObserver';
export var useElementRectObserver = function (element, callback, contentWindow) {
    var observer = useCallback(callback, []);
    useEffect(function () {
        var resizeObserver = new ElementRectObserver(function (rect) {
            observer(rect);
        }, contentWindow);
        if (element) {
            resizeObserver.observe(element);
        }
        return function () {
            if (element) {
                resizeObserver.unobserve(element);
            }
        };
    }, [element]);
};
export default useElementRectObserver;
