"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ElementRectObserver = void 0;
var resize_observer_polyfill_1 = __importDefault(require("resize-observer-polyfill"));
var intersection_observer_1 = __importDefault(require("intersection-observer"));
var ElementRectObserver = (function () {
    function ElementRectObserver(listener, contentWindow) {
        var _this = this;
        if (contentWindow === void 0) { contentWindow = window; }
        this.onChange = function () {
            var _a;
            _this.listener((_a = _this.target) === null || _a === void 0 ? void 0 : _a.getBoundingClientRect());
        };
        this.listener = listener;
        this.contentWindow = contentWindow;
        this.resizeObserver = new resize_observer_polyfill_1.default(this.onChange);
        this.intersectionObserver = new intersection_observer_1.default(this.onChange);
    }
    ElementRectObserver.prototype.observe = function (element) {
        this.target = element;
        this.resizeObserver.observe(element);
        this.intersectionObserver.observe(element);
        this.contentWindow.addEventListener('resize', this.onChange);
        this.contentWindow.addEventListener('scroll', this.onChange);
    };
    ElementRectObserver.prototype.unobserve = function (element) {
        this.target = null;
        this.resizeObserver.unobserve(element);
        this.intersectionObserver.unobserve(element);
        this.contentWindow.removeEventListener('resize', this.onChange);
        this.contentWindow.removeEventListener('scroll', this.onChange);
    };
    return ElementRectObserver;
}());
exports.ElementRectObserver = ElementRectObserver;
