"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useElementRectObserver = void 0;
var react_1 = require("react");
var ElementRectObserver_1 = require("./ElementRectObserver");
exports.useElementRectObserver = function (element, callback, contentWindow) {
    var observer = react_1.useCallback(callback, []);
    react_1.useEffect(function () {
        var resizeObserver = new ElementRectObserver_1.ElementRectObserver(function (rect) {
            observer(rect);
        }, contentWindow);
        if (element) {
            resizeObserver.observe(element);
        }
        return function () {
            if (element) {
                resizeObserver.unobserve(element);
            }
        };
    }, [element]);
};
exports.default = exports.useElementRectObserver;
